/* allegro_4.c
 * Ukazka programu v Allegru 
 * Predvadi, jak pouzit doublebuffering v Allegru
 *
 * Bernard Lidicky - 2004
 *
 * Je pod licenci GPL
 *
 * pro preklad mi fungovalo: "gcc allegro_4.c -o allegro_4 `allegro-config --cflags --libs`"
 */
 
#include <stdio.h>
#include <allegro.h>

// nastaveni rozliseni 
// V normalni hre by se melo nacotat z konfiguracniho souboru
#define SCREEN_X   640
#define SCREEN_Y   480
#define SCREEN_BPP  16


// druha bitmapa velikosti obrazovky
BITMAP *back = NULL; // kam se ma kreslit
BITMAP *page_1, *page_2; // bitmapy pro doublebuffering

// Funkce main
int main( )
{
	
	BITMAP *ryba;
	int x = 0, y = 0;
	
	// Inicializace Allegra
	if ( allegro_init() < 0 ) {
		fprintf(stderr, "Selhala inicializace Allegra.\n");
		exit(1);
	}

	// nastaveni barevne hloubky
	set_color_depth(SCREEN_BPP);
	
	// nastaveni grafickeho modu
//	if ( set_gfx_mode(GFX_AUTODETECT, SCREEN_X, SCREEN_Y, 0, 0) != 0 ){
	if ( set_gfx_mode(GFX_XWINDOWS, SCREEN_X, SCREEN_Y, 0, 0) != 0 ){
			fprintf(stderr, "Nepodarilo nastavit rozliseni %dx%dx%d\n", SCREEN_X, SCREEN_Y, SCREEN_BPP);
			exit(1);
	}
	
	// vytvorime 1. obrazovku obrazovku
	page_1 = create_video_bitmap(SCREEN_X, SCREEN_Y);
	if ( page_1 == NULL ) {
		fprintf(stderr, "Nepodarilo se vytvorit 1. video bitmapu.\n");
		exit(1);
	}
	
	// vytvorime 2. obrazovku
	page_2 = create_video_bitmap(SCREEN_X, SCREEN_Y);
	if ( page_2 == NULL ) {
		fprintf(stderr, "Nepodarilo se vytvorit druhou video bitmapu.\n");
		exit(1);
	}
	
	
	// nacteme bitmaku
	ryba = load_bitmap( "ryba.bmp", NULL );
	if ( ryba == NULL ) {
		fprintf(stderr, "Nepodarilo se nacist soubor ryba.bmp.\n");
		exit(1);
	}

	// 1. inicializace
	back = page_1;
	
	while ( y < SCREEN_Y ) {
		clear_to_color(back, makecol(80, 180, 250));    //  smazani obrazovky

		// nakreslime nekolik ryb
		draw_sprite(back, ryba, x, y); 
		draw_sprite(back, ryba, x, SCREEN_Y-y); 
		draw_sprite(back, ryba, x, SCREEN_Y/2); 
		draw_sprite(back, ryba, SCREEN_Y/2, y);
		
		x++, y++;

		// aktualizace obrazovku
		show_video_bitmap(back);
			
		// prehozeni mista, kam se bude kreslit
		if ( back == page_1 ) back = page_2;
		else back = page_1;
		
	}
	

	// uvolneni nactene bitmapky
	destroy_bitmap(ryba);

	// uvolneni bitmapy s vidooobrazovkami
	destroy_bitmap(page_1);
	destroy_bitmap(page_2);
	
	
	// ukonceni Allegra - neni nutne volat
	allegro_exit();
	
	return 0;
}
// tohle musi byt za funkci main - zalezitost allegra
END_OF_MAIN();
